Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Nikon.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Nikon.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Nikon.pm	(revision 34921)
@@ -2989,8 +4952,8 @@
         Mask => 0x07,
         PrintConv => {
-            0x00 => 'Horizontal',
-            0x01 => 'Rotated 270 CW',
-            0x02 => 'Rotated 90 CW',
-            0x03 => 'Rotated 180',
+            0 => 'Horizontal',
+            1 => 'Rotate 270 CW',
+            2 => 'Rotate 90 CW',
+            3 => 'Rotate 180',
         },
     },
@@ -2999,6 +4962,6 @@
         Mask => 0x18,
         PrintConv => {
-            0x00 => 'Off',
-            0x18 => 'On',
+            0 => 'Off',
+            3 => 'On',
         },
     },
@@ -3007,6 +4970,6 @@
         Mask => 0xe0,
         PrintConv => { BITMASK => {
-            6 => 'Internal',
-            7 => 'External',
+            1 => 'Internal',
+            2 => 'External',
         }},
     },
@@ -3015,7 +4978,7 @@
         Mask => 0xf0,
         PrintConv => {
-            0x00 => 'Large (10.0 M)',
-            0x10 => 'Medium (5.6 M)',
-            0x20 => 'Small (2.5 M)',
+            0 => 'Large (10.0 M)',
+            1 => 'Medium (5.6 M)',
+            2 => 'Small (2.5 M)',
         },
     },
@@ -3040,5 +5003,5 @@
         },
     },
-    # note: DecryptLen currently set to 764
+    # note: DecryptLen currently set to 765
 );
 
@@ -3124,7 +5087,7 @@
         Mask => 0x18,
         PrintConv => {
-            0x00 => 'Large',
-            0x08 => 'Medium',
-            0x10 => 'Small',
+            0 => 'Large',
+            1 => 'Medium',
+            2 => 'Small',
         },
     },
@@ -3203,5 +5166,5 @@
     0x27f => {
         Name => 'ShutterCount',
-        Condition => '$$self{FirmwareVersion} =~ /^2.0[012]/',
+        Condition => '$$self{FirmwareVersion} =~ /^2.0/',
         Notes => 'firmware 2.00, 2.01 and 2.02',
         Format => 'int32u',
@@ -3212,7 +5175,7 @@
         Mask => 0x18,
         PrintConv => {
-            0x00 => 'Large',
-            0x08 => 'Medium',
-            0x10 => 'Small',
+            0 => 'Large',
+            1 => 'Medium',
+            2 => 'Small',
         },
     },
@@ -3341,10 +5304,10 @@
     0x2ce => { #(NC)
         Name => 'CustomSettingsD3S',
-        Format => 'undef[24]',
+        Format => 'undef[27]',
         SubDirectory => {
             TagTable => 'Image::ExifTool::NikonCustom::SettingsD3',
         },
     },
-    # note: DecryptLen currently set to 0x2e6
+    # note: DecryptLen currently set to 0x2e9
 );
 
@@ -3448,4 +5411,5 @@
     CHECK_PROC => \&Image::ExifTool::CheckBinaryData,
     VARS => { ID_LABEL => 'Index' },
+    DATAMEMBER => [ 4 ],
     IS_SUBDIR => [ 802 ],
     WRITABLE => 1,
@@ -3463,6 +5427,8 @@
     0x04 => { #PH
         Name => 'FirmwareVersion',
+        DataMember => 'FirmwareVersion',
         Format => 'string[5]',
         Writable => 0,
+        RawConv => '$$self{FirmwareVersion} = $val',
     },
     613 => {
@@ -3478,6 +5444,58 @@
         Priority => 0,
     },
-    732 => {
+    732 => [{
         Name => 'AFFineTuneAdj',
+        Condition => '$$self{FirmwareVersion} eq "1.10B"',
+        Notes => 'firmware version 1.10B',
+        Format => 'int16u',
+        PrintHex => 1,
+        PrintConvColumns => 3,
+        # thanks to Michael Tapes for the samples to decode this!...
+        PrintConv => {
+            0xe03e => '+20',
+            0xc83e => '+19',
+            0xb03e => '+18',
+            0x983e => '+17',
+            0x803e => '+16',
+            0x683e => '+15',
+            0x503e => '+14',
+            0x383e => '+13',
+            0x203e => '+12',
+            0x083e => '+11',
+            0xe03d => '+10',
+            0xb03d => '+9',
+            0x803d => '+8',
+            0x503d => '+7',
+            0x203d => '+6',
+            0xe03c => '+5',
+            0x803c => '+4',
+            0x203c => '+3',
+            0x803b => '+2',
+            0x803a => '+1',
+            0x0000 => '0',
+            0x80c6 => '-1',
+            0x80c5 => '-2',
+            0x20c4 => '-3',
+            0x80c4 => '-4',
+            0xe0c4 => '-5',
+            0x20c3 => '-6',
+            0x50c3 => '-7',
+            0x80c3 => '-8',
+            0xb0c3 => '-9',
+            0xe0c3 => '-10',
+            0x08c2 => '-11',
+            0x20c2 => '-12',
+            0x38c2 => '-13',
+            0x50c2 => '-14',
+            0x68c2 => '-15',
+            0x80c2 => '-16',
+            0x98c2 => '-17',
+            0xb0c2 => '-18',
+            0xc8c2 => '-19',
+            0xe0c2 => '-20',
+        },
+    },{
+        Name => 'AFFineTuneAdj',
+        Notes => 'other versions',
         Format => 'int16u',
         PrintHex => 1,
@@ -3527,5 +5545,5 @@
             0x90c2 => '-20',
         },
-    },
+    }],
     802 => {
         Name => 'CustomSettingsD300',
@@ -3676,4 +5694,77 @@
 );
 
+# shot information for the D5100 firmware 1.00f (encrypted) - ref PH
+%Image::ExifTool::Nikon::ShotInfoD5100 = (
+    PROCESS_PROC => \&Image::ExifTool::Nikon::ProcessNikonEncrypted,
+    WRITE_PROC => \&Image::ExifTool::Nikon::ProcessNikonEncrypted,
+    CHECK_PROC => \&Image::ExifTool::CheckBinaryData,
+    VARS => { ID_LABEL => 'Index' },
+    IS_SUBDIR => [ 0x407 ],
+    WRITABLE => 1,
+    FIRST_ENTRY => 0,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    0x00 => {
+        Name => 'ShotInfoVersion',
+        Format => 'string[4]',
+        Writable => 0,
+    },
+    0x04 => {
+        Name => 'FirmwareVersion',
+        Format => 'string[5]',
+        Writable => 0,
+    },
+    0x321 => {
+        Name => 'ShutterCount',
+        Format => 'int32u',
+        Priority => 0,
+    },
+    0x407 => {
+        Name => 'CustomSettingsD5100',
+        Format => 'undef[34]',
+        SubDirectory => {
+            TagTable => 'Image::ExifTool::NikonCustom::SettingsD5100',
+        },
+    },
+    # note: DecryptLen currently set to 0x430
+);
+
+# shot information for the D5200 firmware 1.00 (encrypted) - ref PH
+%Image::ExifTool::Nikon::ShotInfoD5200 = (
+    PROCESS_PROC => \&Image::ExifTool::Nikon::ProcessNikonEncrypted,
+    WRITE_PROC => \&Image::ExifTool::Nikon::ProcessNikonEncrypted,
+    CHECK_PROC => \&Image::ExifTool::CheckBinaryData,
+    VARS => { ID_LABEL => 'Index' },
+    IS_SUBDIR => [ 0xcd5 ],
+    WRITABLE => 1,
+    FIRST_ENTRY => 0,
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    0x00 => {
+        Name => 'ShotInfoVersion',
+        Format => 'string[4]',
+        Writable => 0,
+    },
+    0x04 => {
+        Name => 'FirmwareVersion',
+        Format => 'string[5]',
+        Writable => 0,
+    },
+    # 0x101 - 2=VR Off, 3=VR On
+    # 0x13d - 0=VR On, 1=VR Off
+    0xbd8 => {
+        Name => 'ShutterCount',
+        Format => 'int32u',
+        Priority => 0,
+    },
+    # 0xcd2 - 12=VR Off, 15=VR On
+    0xcd5 => {
+        Name => 'CustomSettingsD5200',
+        Format => 'undef[34]',
+        SubDirectory => {
+            TagTable => 'Image::ExifTool::NikonCustom::SettingsD5200',
+        },
+    },
+    # note: DecryptLen currently set to 0xd00
+);
+
 # shot information for the D7000 firmware 1.01d (encrypted) - ref 29
 %Image::ExifTool::Nikon::ShotInfoD7000 = (
